%include "./utils/pci.asm"

find_xhci:

push ebx
push dx

; Enable Bit    Reserved    Bus Number  Device Number   Function Number Register Offset
; 31            30 - 24     23 - 16     15 - 11         10 - 8          7 - 0

mov eax, 1_0000000_00000000_00000_000_00000000b

find_xhci.next:
    mov ebx, eax
    
    ; Check if there is a device
    read_pci_register
    cmp eax, 0xFFFF_FFFF
    je find_xhci.end_check

    ; Check if xHCI
    mov eax, ebx
    mov al, 8
    read_pci_register
    and eax, 0xFF_FF_FF_00
    cmp eax, 0x0C_03_30_00
    je find_xhci.end

find_xhci.end_check:
    mov eax, ebx
    add eax, 0_0000000_00000000_00001_000_00000000b
    cmp eax, 1_0000001_00000000_00000_000_00000000b
    jne find_xhci.next
    jmp $

find_xhci.end:
    mov eax, ebx

    pop dx
    pop ebx

    ret