%include "./utils/vga.asm"


; Example usage:

; COLOR equ BLUE << 4 | GREEN
; mov edi, 0x04               ; Where to print in screen
; mov dh, COLOR
; mov dl, 0x0C                ; Hexadecimal number to print

; call print_hex

print_hex:
    push es
    push dx
    push edi
    and dl, 0x0F
    cmp dl, 0x0A    ; Check if we must print a number [0-9] or a letter [A-F]
    jge print_hex.is_letter
    add dl, '0'
    jmp print_hex.end_adding
print_hex.is_letter:
    add dl, 'A'-0x0A
print_hex.end_adding:
    mov di, VGA_MEMORY >> 4
    mov es, di
    pop edi
    mov [es:edi*2], dx
    inc edi
    pop dx
    pop es
    ret

print_hex_PM:
    push dx
    and dl, 0x0F
    cmp dl, 0x0A    ; Check if we must print a number [0-9] or a letter [A-F]
    jge print_hex_PM.is_letter
    add dl, '0'
    jmp print_hex_PM.end_adding
print_hex_PM.is_letter:
    add dl, 'A'-0x0A
print_hex_PM.end_adding:
    mov [es:edi*2+0xB8000], dx
    inc edi
    pop dx
    ret


; Example usage:

; COLOR equ BLUE << 4 | GREEN
; mov esi, string             ; String to print
; mov edi, 0x04               ; Where to print in screen
; mov dh, COLOR

; call print_str

print_str:
    push es
    push dx
    push esi
    ; DI is not pushed/poped so you can
    ; get the last printed location to
    ; keep printing more easily
    mov si, VGA_MEMORY >> 4
    mov es, si
    mov esi, [esp]
print_str.print:
    mov dl, [esi]   ; dl contains the character each time
    cmp dl, 0
    jz print_str.end
    inc esi
    mov [es:edi*2], dx
    inc edi
    jmp print_str.print
print_str.end:
    pop esi
    pop dx
    pop es
    ret

print_str_PM:
    push dx
    push esi
    ; DI is not pushed/poped so you can
    ; get the last printed location to
    ; keep printing more easily
print_str_PM.print:
    mov dl, [esi]   ; dl contains the character each time
    cmp dl, 0
    jz print_str_PM.end
    inc esi
    mov [es:edi*2+0xB8000], dx
    inc edi
    jmp print_str_PM.print
print_str_PM.end:
    pop esi
    pop dx
    ret